classification
Title: Adds window resizing support to Lib/pty.py [ SIGWINCH ]
Type: enhancement Stage: resolved
Components: Library (Lib) Versions: Python 3.10, Python 3.9, Python 3.8, Python 3.7
process
Status: open Resolution:
Dependencies: Superseder:
Assigned To: Nosy List: soumendra
Priority: normal Keywords: patch

Created on 2020-08-06 11:10 by soumendra, last changed 2020-09-19 23:33 by soumendra.

Files
File name Uploaded Description Edit
pty.diff soumendra, 2020-08-06 11:10 v0.1
pty.diff soumendra, 2020-08-08 00:13 v0.2
Pull Requests
URL Status Linked Edit
PR 21752 closed soumendra, 2020-08-06 11:58
Messages (6)
msg374926 - (view) Author: Soumendra Ganguly (soumendra) * Date: 2020-08-06 11:10
This was tested using Python 3.7 after commenting out the sys.audit lines.

https://docs.python.org/3/library/pty.html presents us with an example usage of pty.spawn. This example mimics script(1). However, the script(1) from util-linux has fantastic signal handing that pty.spawn does not directly provide. In fact, Lib/pty.py says "Bugs: No signal handling. Doesn't set slave termios and window size."

xterm(1) on Debian 10 GNU/Linux was used to test the pty.spawn example mentioned above; upon resizing the xterm(1) window, the output of programs such as ls(1) became scattered and hard to visually parse.

This patch does not modify any of the functions that are already present in Lib/pty. Instead, it exposes a new function called "wspawn" [ pty.wspawn ]. This is like pty.spawn + the following differences.

1. Window size is set at the beginning.
2. A SIGWINCH handler is registered. The old handler is saved and restored later.
3. If the above two steps fail, then cleanup is done, and an exception is raised, so that the programmer can catch the exception and use pty.spawn instead.
4. Unlike pty.spawn, this does not depend on OSError to break out of the parent mainloop. Instead, the main loop calls select with an adjustable  timeout, so that waitpid with WNOHANG can be called periodically to check if the spawned child process has undergone an alteration of state.
5. While the return value is same as that of pty.spawn, this accepts an extra optional "timeout" argument for the select call.

The aforementioned pty.spawn example now works well with window resizing if pty.wspawn is used in place of pty.spawn.

Signed-off-by: Soumendra Ganguly <soumendraganguly@gmail.com>
msg375025 - (view) Author: Soumendra Ganguly (soumendra) * Date: 2020-08-08 00:13
Updated diff.

Changes _ekill()
msg375044 - (view) Author: Soumendra Ganguly (soumendra) * Date: 2020-08-08 11:23
The following are two [ very old ] stackoverflow threads that are relevant.

https://stackoverflow.com/questions/6418678/resize-the-terminal-with-python

https://stackoverflow.com/questions/16941885/want-to-resize-terminal-windows-in-python-working-but-not-quite-right
msg375086 - (view) Author: Soumendra Ganguly (soumendra) * Date: 2020-08-09 22:29
Possibly related issues:

https://bugs.python.org/issue29070
https://bugs.python.org/issue26228

Since wspawn does not depend on OSError, it might be a possible [ not necessarily the only way ] of solving the above issues.
msg375314 - (view) Author: Soumendra Ganguly (soumendra) * Date: 2020-08-13 15:36
Closing because registering SIGWINCH handler from within library function is impractical.
msg377196 - (view) Author: Soumendra Ganguly (soumendra) * Date: 2020-09-19 23:33
Reopening to indicate that this issue has not been resolved. However, this thread should not be used anymore. Use this instead: https://bugs.python.org/issue41818
History
Date User Action Args
2020-09-19 23:33:03soumendrasetstatus: closed -> open

messages: + msg377196
2020-08-13 15:36:24soumendrasetstatus: open -> closed
stage: patch review -> resolved
2020-08-13 15:36:19soumendrasetmessages: + msg375314
2020-08-09 22:29:21soumendrasetmessages: + msg375086
2020-08-08 11:27:17soumendrasettitle: Adds window resizing support to Lib/pty.py -> Adds window resizing support to Lib/pty.py [ SIGWINCH ]
2020-08-08 11:26:03soumendrasettitle: Adds window resizing support to Lib/pty.py for proper output rendering -> Adds window resizing support to Lib/pty.py
2020-08-08 11:23:50soumendrasetmessages: + msg375044
2020-08-08 11:14:45soumendrasettitle: Add window resizing support [ SIGWINCH ] to Lib/pty -> Adds window resizing support to Lib/pty.py for proper output rendering
2020-08-08 00:13:06soumendrasetfiles: + pty.diff

messages: + msg375025
2020-08-06 11:58:56soumendrasetstage: patch review
pull_requests: + pull_request20896
2020-08-06 11:10:23soumendracreate